% Calculate correlation coefficients of a matrix with missing values.
% Fill the NA entries by the mean values of each column.

function val = new_missing_corrcoef(mat)

%aa=find(~((mat>=0)|(mat<0)));
%mat(aa)=0;

ncols=length(mat(1,:)); nrows=length(mat(:,1));
for i=1:ncols
ii=find((mat(:,i)>=0)|(mat(:,i)<0));
jj=setdiff(1:nrows,ii);
mval=mean(mat(ii,i));

mat(jj,i)=mval;
end

val=corrcoef(mat);

