% Recursively label nodes in a bipartite graph.
function [labeled1, labeled2] = recurse_label(type, ind, n1, n2, G, labeled1, labeled2, label)

% type=1: ind is a type 1 node.
% type=2: ind is a type 2 node.

% Label the target node.
if (type==1)
labeled1(ind)=label;

%[type ind labeled1(ind)]

elseif (type==2)
labeled2(ind)=label;

end

% Recursively visit neighbors.
if (type==1)
tmp=find(G(ind,:)>0);

% If all neighbors are labeled, then return.
if (sum(labeled2(tmp)==0)>0)

for i=1:length(tmp)

if (labeled2(tmp(i))==0)
[labeled1,labeled2]=recurse_label(2,tmp(i),n1,n2,G,labeled1,labeled2,label);
end
end
end

elseif (type==2)
tmp=find(G(:,ind)>0);

% If all neighbors are labeled, then return.
if (sum(labeled1(tmp)==0)>0)

for i=1:length(tmp)

if (labeled1(tmp(i))==0)
[labeled1,labeled2]=recurse_label(1,tmp(i),n1,n2,G,labeled1,labeled2,label);
end
end
end
end


